

## This is a threaded osX Bar Engine
## GPL from stefanux @ libero .it
## created for osX Bar

import XBarSensor
import karamba
import time

## This is a wrapper code used to link modules with osX Bar
## TODO: Porting all graphics functions here
theUpdateIcon = 0
theUpdateText = 0
theWidget = 0
theAddIcon=0

## Sensors configurations
SysSensorListIndex=[]
SysSensorListType=[]
SysSensorListCmd=[]
SysSensorListSleep=[]
SysSensorListMax=[]

imgSplashScreen = 0

def TimeStep():
	global SysSensorListMax
	global SysSensorListSleep
	## Searching for the Timeouts
	for ssI in range (len(SysSensorListMax)):
		SysSensorListSleep[ssI]=SysSensorListSleep[ssI]+1
		if(SysSensorListSleep[ssI]>SysSensorListMax[ssI]):
			## TimeOut on ssI sensor
			## Call update of sensor
			SysSensorListSleep[ssI]=0
			XBarSensor.XBarSensorUpdateSensor(ssI)


def ShowSplashScreen(widget):
	global imgSplashScreen
	karamba.moveWidget(widget,100,100)
	karamba.resizeWidget(widget,300,300)
	imgSplashScreen=karamba.createImage(widget,0,0,"background.png")
	karamba.redrawWidget(widget)


## Setup the links
def EngineSetup(widget,eUpdateIcon,eUpdateText,eAddIcon):
	global theWidget
	global theUpdateIcon
	global theUpdateText
	global SysSensorListMax
	global imgSplashScreen
	global SysSensorListSleep
	global theAddIcon
	theUpdateIcon=eUpdateIcon
	theUpdateText=eUpdateText
	theAddIcon=eAddIcon
	theWidget=widget
	## We have to init the Timeouts
	for ssI in range (len(SysSensorListIndex)):
		SysSensorListSleep.append(0)
		SysSensorListMax[ssI]=int(SysSensorListMax[ssI])
		SysSensorListIndex[ssI]=int(SysSensorListIndex[ssI])
		SysSensorListType[ssI]=int(SysSensorListType[ssI])
	## Setup User configurations Menu
	##ShowSplashScreen(widget)
	##time.sleep(10)
	##karamba.deleteImage(widget,imgSplashScreen)



## Wrapper
def UpdateIcon(theIndex,newFile):
	global theWidget
	global theUpdateIcon
	## Superkaramba 0.27 doen't support multi-thread engine
	theUpdateIcon(theWidget,theIndex,newFile)

def UpdateText(theIndex,newText):
	global theWidget
	global theUpdateText
	## Superkaramba 0.27 doen't support multi-thread engine
	theUpdateText(theWidget,theIndex,newText)

def AddIcon(oText,fIcon,sCmd):
	global theWidget
	global theAddIcon
	theAddIcon(theWidget,oText,fIcon,sCmd)

## When loading osX Bar extensions
print "osX Bar Thread Engine Module loaded. [Version 0.2]"
